/*----------------------------------------------------------------------------+
|   Copyright (C) 2004  Hsu-Ping Feng                                         |
|                                                                             |
|   This program is free software; you can redistribute it and/or modify      |
|   it under the terms of the GNU General Public License as published by      |
|   the Free Software Foundation; either version 2 of the License, or         |
|   (at your option) any later version.                                       |
|                                                                             |
|   This program is distributed in the hope that it will be useful,           |
|   but WITHOUT ANY WARRANTY; without even the implied warranty of            |
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
|   GNU General Public License for more details.                              |
|                                                                             |
|   You should have received a copy of the GNU General Public License         |
|   along with this program; if not, write to the Free Software               |
|                                                                             |
|   Foundation, Inc., 59 Temple Place, Suite 330,                             |
|   Boston, MA  02111-1307 USA                                                |
|                                                                             |
|                                                                             |
|   Author e-mail: spferng@ksts.seed.net.tw                                   |
+----------------------------------------------------------------------------*/
#include <conio.h>
#include "common.h"
#include "bootmgr.h"
#include "fdisk.h"

sword   g_WriteSW = TRUE;                        /**  driver gJ} **/
DiskDT  *g_DTable = NULL;          /** VɰtmnBwаѼƪ(}C) **/
INFO    g_Info;            /** XtθTcAҰʺ޲z{εwФΤu **/
word    g_TextArea[TEXT_MAX_Y][TEXT_MAX_X];            /** ܰϪr **/

Screen  g_CurPos = { FALSE,                          /** O_wJøϼҦ **/
                       0,                                /** ثeЦm X **/
                       0,                                /** ثeЦm Y **/
                       INIT_COLOR,               /** rCAw]ũզr **/
                       CURSOR_COLOR,                           /** C **/
                       0,                                  /** ܺX **/
                       0 };                            /** ܪAX **/


/*----------------------------------------------------------------------------+
|                      SPF Boot Manager use global variable                   |
+-----------------------------------------------------------------------------+
|        FKҰʺ޲z{]wΦwˡAҥHNHUܼƳ]ܼ       |
+----------------------------------------------------------------------------*/
sbyte     g_Magic_Str[9] = "SPFDisk.";    /** Magic Str must first variable **/

BOOTPARA  g_BootPara = { 0 };                  /** sҰʺ޲z{tγ]w **/
BMGR      g_Boot[REC_NUMBER] = { 0 };        /** sҰʺ޲z{} **/

byte      g_EndLoad[] = "";                /** JҰʿɭpJץ **/

volatile word  bm_Timer   = NO_TIMER; /** Ұʮɦbɶʧ@Kww]} **/
volatile word  bm_Counter = 0;           /** }ɥΨӭp timer _ **/

/*------------------------+
|      System ID Name     |
+------------------------*/
#if ( LANGUAGE_SELE != CHINESE )
    sbyte bm_BootTitle[] = "Boot Menu",
          bm_FsTitle[]   = "File System",
          bm_PmtStr[]    = ":Move light bar  []:OK ",
          bm_ErrorMsg[]  = "!! Partition not exist or bad boot sector !!\x7",
          bm_PwPmtStr[]  = "Enter Password: ",
          bm_PwErrStr[]  = "!!!! PASSWORD INCORRECT !!!!!",
          bm_Introduce[] = "$ SPFDisk Boot Manager"
                           "    Version NO. "  VERSION  "     Programmer: Hsu-Ping Feng ";
    static sbyte ID_26[] = "[Hidden]";
    static sbyte ID_UN[] = "UNKNOW";
    static sbyte ID_FP[] = "Floppy";
    static sbyte ID_BD[] = "BAK_ID LOST";
    static sbyte ID_NE[] = "[Invalid]";

#elif ( CHINESE_SELE == TRANDITION )
    sbyte bm_BootTitle[] = "   ",
          bm_FsTitle[]   = "  t ",
          bm_PmtStr[]    = ":ʥ  []:T{ ",
          bm_ErrorMsg[]  = "I ҰʪΤsbΤOĪҰʺϰ I\x7",
          bm_PwPmtStr[]  = "пJqKXG ",
          bm_PwErrStr[]  = "!!!!!!   K X  ~   !!!!!!",
          bm_Introduce[] = " SPFDisk    z {    x sG"
                           VERSION  " x {]pG ";
    static sbyte ID_26[] = "[ä]";
    static sbyte ID_UN[] = "ԪtID";
    static sbyte ID_FP[] = "nо";
    static sbyte ID_BD[] = "ƥID";
    static sbyte ID_NE[] = "[ثeLkҰ]";

#elif ( CHINESE_SELE == SIMPLE )
    sbyte bm_BootTitle[] = "E   ",
          bm_FsTitle[]   = "  t ",
          bm_PmtStr[]    = ":ʥ  []:T{ ",
          bm_ErrorMsg[]  = "I EϤsbΤOĪ޾ɮ I\x7",
          bm_PwPmtStr[]  = "пJqKXG ",
          bm_PwErrStr[]  = "!!!!!!   K X  ~   !!!!!!",
          bm_Introduce[] = " SPFDisk   {   z   x sG"
                           VERSION  " x {ǳ]pG ";
    static sbyte ID_26[] = "[ä]";
    static sbyte ID_UN[] = "ԪtID";
    static sbyte ID_FP[] = "nL";
    static sbyte ID_BD[] = "ƥID";
    static sbyte ID_NE[] = "[ثeLkE]";

#else
    #error Language configure is not support!!!
#endif


static sbyte ID_00[] = "none";
static sbyte ID_01[] = "DOS FAT12";
static sbyte ID_02[] = "XENIX root";
static sbyte ID_03[] = "XENIX usr";
static sbyte ID_04[] = "DOS FAT16 <32M";
static sbyte ID_05[] = "Extended";
static sbyte ID_06[] = "DOS FAT16 >=32M";
static sbyte ID_07[] = "HPFS/NTFS";
static sbyte ID_08[] = "AIX";
static sbyte ID_09[] = "AIX bootable";
static sbyte ID_0A[] = "OS/2 Boot Manag";
static sbyte ID_0B[] = "DOS FAT32";
static sbyte ID_0C[] = "DOS FAT32(LBA)";
static sbyte ID_0E[] = "DOS FATs(LBA)";
static sbyte ID_0F[] = "DOS Extend(LBA)";
static sbyte ID_10[] = "OPUS";
static sbyte ID_12[] = "Compaq diagnost";
static sbyte ID_18[] = "AST WindowsSwap";
static sbyte ID_20[] = "SPF Boot Manage";
static sbyte ID_24[] = "NECDOS";
static sbyte ID_39[] = "Plan9";
static sbyte ID_3C[] = "Partition Magic";
static sbyte ID_40[] = "Venix 80286";
static sbyte ID_41[] = "PPC PReP Boot";
static sbyte ID_42[] = "SFS";
static sbyte ID_4D[] = "QNX4.x";
static sbyte ID_4E[] = "QNX4.x 2nd part";
static sbyte ID_4F[] = "QNX4.x 3nd part";
static sbyte ID_50[] = "OnTrack DM";
static sbyte ID_51[] = "OnTrack DM6 Aux";
static sbyte ID_52[] = "CP/M";
static sbyte ID_53[] = "OnTrack DM6 Aux";
static sbyte ID_54[] = "OnTrack DM6";
static sbyte ID_55[] = "EZ-Drive";
static sbyte ID_56[] = "Golden Bow";
static sbyte ID_5C[] = "Priam Edisk";
static sbyte ID_61[] = "SpeedStor";
static sbyte ID_63[] = "GNU HURD";
static sbyte ID_64[] = "Novell Netware";
static sbyte ID_65[] = "Novell Netware";
static sbyte ID_70[] = "DiskSecure Mult";
static sbyte ID_75[] = "PC/IX";
static sbyte ID_80[] = "Old MINIX";
static sbyte ID_81[] = "MINIX/old Linux";
static sbyte ID_82[] = "Linux swap";
static sbyte ID_83[] = "Linux native";
static sbyte ID_84[] = "hidden OS/2 C:";
static sbyte ID_85[] = "Linux extended";
static sbyte ID_86[] = "NTFS volume set";
static sbyte ID_87[] = "NTFS volume set";
static sbyte ID_8E[] = "Linux LVM";
static sbyte ID_93[] = "Amoeba";
static sbyte ID_94[] = "Amoeba BBT";
static sbyte ID_9F[] = "BSD/OS";
static sbyte ID_A0[] = "IBM Thinkpad hi";
static sbyte ID_A5[] = "FreeBSD";
static sbyte ID_A6[] = "Open BSD";
static sbyte ID_A7[] = "NEXTSTEP";
static sbyte ID_A9[] = "NetBSD";
static sbyte ID_AF[] = "HFS";
static sbyte ID_B7[] = "BSDI fs";
static sbyte ID_B8[] = "BSDI swap";
static sbyte ID_C1[] = "DRDOS/sec FAT";
static sbyte ID_C4[] = "DRDOS/sec FAT";
static sbyte ID_C6[] = "DRDOS/sec FAT";
static sbyte ID_C7[] = "Syrinx";
static sbyte ID_DA[] = "Non-FS data";
static sbyte ID_DB[] = "CP/M";
static sbyte ID_DE[] = "Dell Utility";
static sbyte ID_E1[] = "DOS access";
static sbyte ID_E3[] = "DOS R/O";
static sbyte ID_E4[] = "SpeedStor";
static sbyte ID_EB[] = "BeOS fs";
static sbyte ID_EE[] = "EFI GPT";
static sbyte ID_EF[] = "EFI (FAT-12/16)";
static sbyte ID_F1[] = "SpeedStor";
static sbyte ID_F2[] = "DOS secondary";
static sbyte ID_F4[] = "SpeedStor";
static sbyte ID_FE[] = "LAN step";
static sbyte ID_FF[] = "BBT";

/*-------------------------------------------------------+
|   System ID ު (@ӫа}CVW ID_Name)    |
|   SysID 100h - 103h UҰʺ޲z{M             |
|   OO UNKNOW_ID(ID_UN),    FLOPPY_ID(ID_FP),        |
|          BAD_HIDD_ID(ID_BD),  NOT_EXIST_ID(ID_NE)      |
+-------------------------------------------------------*/
sbyte *g_SysName[] =
{
    ID_00,  ID_01,  ID_02,  ID_03,  ID_04,  ID_05,  ID_06,  ID_07,
    ID_08,  ID_09,  ID_0A,  ID_0B,  ID_0C,  ID_UN,  ID_0E,  ID_0F,
    ID_10,  ID_26,  ID_12,  ID_UN,  ID_26,  ID_UN,  ID_26,  ID_26,
    ID_18,  ID_UN,  ID_UN,  ID_26,  ID_26,  ID_UN,  ID_26,  ID_UN,
    ID_20,  ID_UN,  ID_UN,  ID_UN,  ID_24,  ID_UN,  ID_26,  ID_UN,
    ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,
    ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,
    ID_UN,  ID_39,  ID_UN,  ID_UN,  ID_3C,  ID_UN,  ID_UN,  ID_UN,
    ID_40,  ID_41,  ID_42,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,
    ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_4D,  ID_4E,  ID_4F,
    ID_50,  ID_51,  ID_52,  ID_53,  ID_54,  ID_55,  ID_56,  ID_5C,
    ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,
    ID_UN,  ID_61,  ID_UN,  ID_63,  ID_64,  ID_65,  ID_UN,  ID_UN,
    ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,
    ID_70,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_75,  ID_UN,  ID_UN,
    ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,
    ID_80,  ID_81,  ID_82,  ID_83,  ID_84,  ID_85,  ID_86,  ID_87,
    ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_8E,  ID_UN,
    ID_UN,  ID_UN,  ID_UN,  ID_93,  ID_94,  ID_UN,  ID_UN,  ID_UN,
    ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_9F,
    ID_A0,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_A5,  ID_A6,  ID_A7,
    ID_UN,  ID_A9,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_AF,
    ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_B7,
    ID_B8,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,
    ID_UN,  ID_C1,  ID_UN,  ID_UN,  ID_C4,  ID_UN,  ID_C6,  ID_C7,
    ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,
    ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,
    ID_UN,  ID_UN,  ID_DA,  ID_DB,  ID_UN,  ID_UN,  ID_DE,  ID_UN,
    ID_UN,  ID_E1,  ID_UN,  ID_E3,  ID_E4,  ID_UN,  ID_UN,  ID_UN,
    ID_UN,  ID_UN,  ID_UN,  ID_EB,  ID_UN,  ID_UN,  ID_EE,  ID_EF,
    ID_UN,  ID_F1,  ID_F2,  ID_UN,  ID_F4,  ID_UN,  ID_UN,  ID_UN,
    ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_UN,  ID_FE,  ID_FF,
    ID_UN,  ID_FP,  ID_BD,  ID_NE
};

sbyte bm_SecStr[]  = "[  ]";
sbyte bm_UpSym[]   = "[]";
sbyte bm_DownSym[] = "[]";

sword bm_BootTime  = FALSE;                            /** ثeO_b} **/
sword bm_QuietSW   = FALSE;                              /** O_RҦ **/

byte  g_DataEnd[] = "";  /** for Install boot manager check end of data **/
