;-----------------------------------------------------------------------------;
;   Copyright (C) 2004  Hsu-Ping Feng                                         ;
;                                                                             ;
;   This program is free software; you can redistribute it and/or modify      ;
;   it under the terms of the GNU General Public License as published by      ;
;   the Free Software Foundation; either version 2 of the License, or         ;
;   (at your option) any later version.                                       ;
;                                                                             ;
;   This program is distributed in the hope that it will be useful,           ;
;   but WITHOUT ANY WARRANTY; without even the implied warranty of            ;
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             ;
;   GNU General Public License for more details.                              ;
;                                                                             ;
;   You should have received a copy of the GNU General Public License         ;
;   along with this program; if not, write to the Free Software               ;
;                                                                             ;
;   Foundation, Inc., 59 Temple Place, Suite 330,                             ;
;   Boston, MA  02111-1307 USA                                                ;
;                                                                             ;
;                                                                             ;
;   Author e-mail: spferng@ksts.seed.net.tw                                   ;
;-----------------------------------------------------------------------------;

;----------------------------------
;     J I/O     c      
;----------------------------------
PACKAGE   STRUCT                        
          Start      DWORD       ?
          ;
          Cyl        WORD        ?
          Head       WORD        ?
          Sector     WORD        ?
          ;
          Disk       BYTE        ?
          nSects     BYTE        ?
PACKAGE   ENDS


;----------------------------------
;    ] w s   m   c
;----------------------------------
DRV_PK    STRUCT
          _Size       BYTE      16
          Reserved1   BYTE       0
          Transfer    BYTE       ?
          Reserved2   BYTE       0
          Buff_OFF    WORD       ?
          Buff_SEG    WORD       ?
          StartLow    DWORD      ?
          StartHigh   DWORD      0
DRV_PK    ENDS


;-------------------------------- CONST define --------------------------------
RETRY_TIMES  EQU      3

CODE_SEG     EQU      7000h
DATA_SEG     EQU      8000h
MBR_SEG      EQU      60h
MBR_OFF      EQU      600h

VER_NO       EQU      0A001h

;COMPILE_MODE EQU     large
COMPILE_MODE EQU      medium
