/*----------------------------------------------------------------------------+
|   Copyright (C) 2004  Hsu-Ping Feng                                         |
|                                                                             |
|   This program is free software; you can redistribute it and/or modify      |
|   it under the terms of the GNU General Public License as published by      |
|   the Free Software Foundation; either version 2 of the License, or         |
|   (at your option) any later version.                                       |
|                                                                             |
|   This program is distributed in the hope that it will be useful,           |
|   but WITHOUT ANY WARRANTY; without even the implied warranty of            |
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
|   GNU General Public License for more details.                              |
|                                                                             |
|   You should have received a copy of the GNU General Public License         |
|   along with this program; if not, write to the Free Software               |
|                                                                             |
|   Foundation, Inc., 59 Temple Place, Suite 330,                             |
|   Boston, MA  02111-1307 USA                                                |
|                                                                             |
|                                                                             |
|   Author e-mail: spferng@ksts.seed.net.tw                                   |
+----------------------------------------------------------------------------*/
#include <stdio.h>
#include <conio.h>
#include "bootmgr.h"
#include "common.h"
#include "global.h"

/*============================= @~T ================================*/
void ShowError (sword code)
{
    static sbyte *msg[] =
    {
        #if ( LANGUAGE_SELE != CHINESE )
            "Out of memory!",
            "Active partition is not found!",
            "MBR rebuild failure!",      /* Install area no setup or no exist! */
            "No storage device found!",
            "Invalid parameter!",
    /* 5 */ "The partition table is invalid!",
            "Partition table access failure!",
            "Disk access failure!",
            "Can't open or create this file!",
            "Extended partition already exists!",
    /* 10 */"This file format is incorrect!",
            "Extended partition does not exist!",       /* "This partition is danger if exchagne\nit!", */
            "Error found in the partition table,\nremainders cut off!",
            "Partitions beyond 99 will be cut off",
            "The primary partition is full,\ninstall failure!",
    /* 15 */"The password set failure!",
            "The UNDO file check sum incorrect!",
            "The hard disk write failure!",
            "Disk space is not enough!",
            "Disk service failure, hardware error\npossibly!",
    /* 20 */"The file length not enough a sector!",
            "The boot sector is not DOS Operating\nSystem!",
            "The partition areas overlap!",
            "Bad sector found in the system area!",
            "Partition area found overlap!",
    /* 25 */"Not enough sectors per track!",
            "Error found in the boot sector!",
            "SPFDisk Boot Manager not found\nor the version incompatible!",
            "No matching data found!",
            "Logic partition does not exist!",
    /* 30 */"One of FAT entry point is illegal!",
            "Two FATs are different!"
    
        #elif ( CHINESE_SELE == TRANDITION )
            "O餣I",
            "S]wҰʤΥiLk}I",
            "ۢТ୫إѡI",                        /* w˰ϨS]wγWI */
            "xs]",
            "LĪѼơI",
    /* 5 */ "LĪwФΪI",
            "ΪsѡI",
            "ϺоsѡI",
            "Lk}ҩΫإߦɡI",
            "XRΤwgsbI",
    /* 10 */"ɮפe~ΪۮeI",
            "XRΤsbI",                   /* "mΥi|MII", */
            "Ϊeo{~AlΡI",
            "WL 99 ӪαNQI",
            "DΤwSŶiwˡI",
    /* 15 */"⦸JۦPI",
            "UNDO `M(Check SUM)TI",
            "wмgJѡI",
            "ϺЪŶI",
            "ϺЪAȤu@ѡAiOw~I",
    /* 20 */"ɮתפ@ӺϰϡI",
            "oӱҰʺϰϤO MS-DOS @~tΡI",
            "PU@ӤΪϰoͭ|I",
            "tκϰϪϰ줺laI",
            "ΰϵoͭ|θƤTI",
    /* 25 */"ŶLkwˡI",
            "tκϰϸƤTΪ̿򥢡I",
            "O SPFDisk ҰʿΪۮeI",
            "䤣ŦXơI",
            "޿ΤsbI",
    /* 30 */"FAT iJI~I",
            " FAT OۦPI"
    
        #elif ( CHINESE_SELE == SIMPLE )
            "O餣I",
            "S]wʤϥiLkEI",
            "ۢТ୫إѡI",                        /* w˰ϨS]wγWI */
            "xs]",
            "LĪѼơI",
    /* 5 */ "LĪwLϪI",
            "ϪsѡI",
            "ϽLsѡI",
            "Lk}ҩγЫئɡI",
            "XRϤwgsbI",
    /* 10 */"ɮפe~ΪۮeI",
            "XRϤsbI",                   /* "mΥi|MII", */
            "Ϫeo{~AlϡI",
            "WL 99 ӪϱNQI",
            "DϤwSŶiwˡI",
    /* 15 */"⦸JۦPI",
            "UNDO `M(Check SUM)TI",
            "wLgJѡI",
            "ϽLŶI",
            "ϽLAȤu@ѡAiOw~I",
    /* 20 */"ɮתפ@ӮϡI",
            "oӤ޾ɮϤO MS-DOS @~tΡI",
            "PU@ӤϪϰoͭ|I",
            "tήϪϰ줺laI",
            "ϵoͭ|θƤTI",
    /* 25 */"ŶLkwˡI",
            "tκϰϸƤTΪ̿򥢡I",
            "O SPFDisk ҰʿΪۮeI",
            "䤣ŦXơI",
            "޿ϤsbI",
    /* 30 */"FAT iJI~I",
            " FAT OۦPI"
    
        #else
            #error Language configure is not support!!!
    
        #endif
    }; /* end msg[] declaration */


    Error_Msg_Box(msg[code], NULL);

} /* end ShowError */

