;-----------------------------------------------------------------------------;
;   Copyright (C) 2004  Hsu-Ping Feng                                         ;
;                                                                             ;
;   This program is free software; you can redistribute it and/or modify      ;
;   it under the terms of the GNU General Public License as published by      ;
;   the Free Software Foundation; either version 2 of the License, or         ;
;   (at your option) any later version.                                       ;
;                                                                             ;
;   This program is distributed in the hope that it will be useful,           ;
;   but WITHOUT ANY WARRANTY; without even the implied warranty of            ;
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             ;
;   GNU General Public License for more details.                              ;
;                                                                             ;
;   You should have received a copy of the GNU General Public License         ;
;   along with this program; if not, write to the Free Software               ;
;                                                                             ;
;   Foundation, Inc., 59 Temple Place, Suite 330,                             ;
;   Boston, MA  02111-1307 USA                                                ;
;                                                                             ;
;                                                                             ;
;   Author e-mail: spferng@ksts.seed.net.tw                                   ;
;-----------------------------------------------------------------------------;
;                                                                             ;
;                       ҰʺϰϵL}{ܵ{q                          ;
;                                                                             ;
;-----------------------------------------------------------------------------;
INCLUDE KERNEL.h

;         .MODEL  small, c
          .MODEL  COMPILE_MODE, c
          public  BOOT_HEAD, BOOT_END, BOOT_DATA

          .386
          .CODE   QKFORMAT_TEXT
BOOT_HEAD:
          cli
          mov  ax, 7c0h
          mov  ds, ax
          mov  ss, ax
          mov  sp, 0
          sti

          cld
BOOT_DATA:
          mov  si, MSG - BOOT_HEAD                ; 2 & 3 byte is MSG-BOOT_HEAD
          .REPEAT
              lodsb
              mov  ah, 0Eh
              xor  bx, bx
              int  10h
          .UNTIL ( al == 0 )

WAIT_KEY:
          mov  ah, 00                                              ; Wait a key
          int  16h

          cli
          xor  ax, ax
          mov  ds, ax
          mov  ss, ax
          mov  sp, 0ffffh
          sti

          int  19h                                               ; Quick reboot


MSG      db        0dh, 0ah, 'The disk is Non-System disk !'
         db        0dh, 0ah, 'Please use System software to make system file .'
         db        0dh, 0ah, 0

BOOT_END:

         END
