/*----------------------------------------------------------------------------+
|   Copyright (C) 2002  Shi-Ping Ferng                                        |
|                                                                             |
|   This program is free software; you can redistribute it and/or modify      |
|   it under the terms of the GNU General Public License as published by      |
|   the Free Software Foundation; either version 2 of the License, or         |
|   (at your option) any later version.                                       |
|                                                                             |
|   This program is distributed in the hope that it will be useful,           |
|   but WITHOUT ANY WARRANTY; without even the implied warranty of            |
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
|   GNU General Public License for more details.                              |
|                                                                             |
|   You should have received a copy of the GNU General Public License         |
|   along with this program; if not, write to the Free Software               |
|                                                                             |
|   Foundation, Inc., 59 Temple Place, Suite 330,                             |
|   Boston, MA  02111-1307 USA                                                |
|                                                                             |
|                                                                             |
|   Author e-mail: spferng@ksts.seed.net.tw                                   |
+----------------------------------------------------------------------------*/

#ifndef __CONFIG_H_
#define __CONFIG_H_

#define VER_NO                  0xa001         /** Ұʺ޲z{xɪ **/
#define VERSION                 "2000-3v"            /** r **/

/*-------------------------------------------------------------------+
|  LANGUAGE_SELE wq CHINESE or ENGLISH or TEXTMODE 䤤@  |
|  ܳ]wᥲNҦ obj ɧRAs compile ~|ͮ          |
+-------------------------------------------------------------------*/
#define ENGLISH                 2

#define GRAPHMODE               1
#define TEXTMODE                2

#define ENG_TEXTMODE_VER        1
#define ENG_GRAPH_MODE_VER      2

#define GEN_VERSION             ENG_GRAPH_MODE_VER

#if ( GEN_VERSION == ENG_TEXTMODE_VER )
    #define DISPLAY_MODE        TEXTMODE
    #define LANGUAGE_SELE       ENGLISH
#else
    #define DISPLAY_MODE        GRAPHMODE
    #define LANGUAGE_SELE       ENGLISH
#endif

#if ( DISPLAY_MODE != TEXTMODE && DISPLAY_MODE != GRAPHMODE )
    #error Incorrect define word -- DISPLAY_MODE
#endif

#if ( LANGUAGE_SELE != CHINESE && LANGUAGE_SELE != ENGLISH )
    #error Incorrect define word -- LANGUAGE_SELE
#endif

#if ( LANGUAGE_SELE == CHINESE && \
      CHINESE_SELE != TRANDITION && CHINESE_SELE != SIMPLE )
    #error Incorrect define word -- CHINESE_SELE
#endif

#define SPF_DEBUG               1             /** ҥ debug {X   **/
#define MSDOS                   1             /** {P MSDOS  **/
#define SUPPORT_QKFORMAT        1             /** ҥ quick format {X  **/

#endif /* __CONFIG_H_ */
