/*----------------------------------------------------------------------------+
|   Copyright (C) 2004  Hsu-Ping Feng                                         |
|                                                                             |
|   This program is free software; you can redistribute it and/or modify      |
|   it under the terms of the GNU General Public License as published by      |
|   the Free Software Foundation; either version 2 of the License, or         |
|   (at your option) any later version.                                       |
|                                                                             |
|   This program is distributed in the hope that it will be useful,           |
|   but WITHOUT ANY WARRANTY; without even the implied warranty of            |
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
|   GNU General Public License for more details.                              |
|                                                                             |
|   You should have received a copy of the GNU General Public License         |
|   along with this program; if not, write to the Free Software               |
|                                                                             |
|   Foundation, Inc., 59 Temple Place, Suite 330,                             |
|   Boston, MA  02111-1307 USA                                                |
|                                                                             |
|                                                                             |
|   Author e-mail: spferng@ksts.seed.net.tw                                   |
+----------------------------------------------------------------------------*/
#include <stdio.h>
#include "fdisk.h"
#include "common.h"
#include "selemenu.h"
#include "global.h"

/*****************************************************************************/
/*                                                                           */
/*    HUƧtX Sele_Partn() ϥΡAUﶵO_iܪ禡   */
/*                                                                           */
/*****************************************************************************/

/*============================================================================+
|   IF DΤp|  THEN ҦWBWγ]i                  |
|                      ELSE yDγzWγ]iܡAlϤ  |
+============================================================================*/
sword General_sele (PARTN *partnArr, sword ndx)
{
    if ( partnArr && ndx >= 0 )
        return(1);
    return(0);
 
 /* return( (partnArr[ndx].no != 0) ||
            (g_Info.fd.primary < 4) && ((partnArr[ndx].start < 1024) ||
            (g_Info.fd.expert)) );
 */
} /* end General */


/*===========================================================================*/
/*              uwWDΥiѿܡAΤɨϥ                 */
/*===========================================================================*/
sword Just_primary (PARTN *partnArr, sword ndx)
{
    PARTN *ptr = partnArr + ndx;
 
    return( (ptr->no > 0) && (ptr->no < 5) );
} /* end Just_primary */


/*===========================================================================*/
/*              uwW޿ΥiѿܡAΤɨϥ               */
/*===========================================================================*/
sword Just_logic (PARTN *partnArr, sword ndx)
{
    return( partnArr[ndx].no > 4 );
} /* end Just_logic */



/*===========================================================================*/
/*      ΦbҰʺ޲z{]wҦw˪ (tmDΰϩ SYS_ID = 0x20)    */
/*===========================================================================*/
sword ID20h_or_unused (PARTN *partnArr, sword ndx)
{
    PARTN *ptr = partnArr + ndx;

    return( ((ptr->no < 5) && (ptr->old_id == 0x20)) ||
            ((g_Info.fd.primary < 4) && (ptr->no == 0)) );
} /* end ID20h_or_unused */


/*===========================================================================*/
/*       ΦbŪҰʺ޲z{Ϊ禡 ( SYS_ID = 0x20 D )     */
/*===========================================================================*/
sword Just_id20h (PARTN *partnArr, sword ndx)
{
    PARTN *ptr = partnArr + ndx;
 
    return( (ptr->no < 5) && (ptr->old_id == 0x20) );
} /* end Just_id20h */

        
/*===========================================================================*/
/*                         WΧ]i                          */
/*===========================================================================*/
sword All_used (PARTN *partnArr, sword ndx)
{ 
    return( partnArr[ndx].id != 0 );
} /* end All_used */

 
/*===========================================================================*/
/*             ϥΪ̦۩wó]wM (bootrec.c ϥΨ)               */
/*===========================================================================*/
static sword  Search_no (DiskDT *dk, sword Par, void *hiddArr);
static sword  gs_Item;
static sword  gs_Number;

sword User_hidden_set (PARTN *partnArr, sword ndx)
{
    extern SeleMenu  g_Menu;
    BMGR   *bptr;
    PARTN  *pptr;
    sword  ret;
 
    ret  = 1;
    pptr = partnArr + ndx;
    bptr = g_Boot + gs_Item;
 
    if ( (pptr->id == 0) ||
         ((bptr->partn == pptr->no) && (bptr->disk == CUR_DK->diskNO)) )
        ret = 0;
    else
    {
        if ( Search_no(CUR_DK, pptr->no, bptr->h_partn) )
            g_Menu.itemColor( HIDD_PARTN_COLOR );      /** QêC **/
        else
        {
            if ( gs_Number == HIDD_ITEM )
                ret = 0;
            g_Menu.itemColor( DEFAULT_COLOR );
        } /* end if */
    } /* end if */
 
    return( ret );
} /* end User_hidden_set */

     
/*----------------------------------------------------------+
|     M O _  w     s   Q w q    |
+----------------------------------------------------------*/
sword Search_no (DiskDT *dk, sword Par, void *hiddArr)
{
    byte  *ptr = (byte *)hiddArr;
 
    for ( ; (*ptr) && \
            ((*ptr < dk->diskNO) || \
             (*ptr == dk->diskNO) && (*(ptr+1) < Par)) ;  ptr += 2 );
    return( (*ptr == dk->diskNO) && (*(ptr+1) == Par) );
}  /* end Search_no */


/*-----------------------------------------------------------+
|            ]wɤ file scope @ܼƤe            |
+-----------------------------------------------------------*/
void set_boot_variable (sword now_item, sword num)
{
    gs_Item   = now_item;
    gs_Number = num;
} /* end set_boot_variable */


